import { Component, OnInit } from '@angular/core';

import Diagram = MindFusion.Diagramming.Diagram;
import HandlesStyle = MindFusion.Diagramming.HandlesStyle;
import Rect = MindFusion.Drawing.Rect;
import GlassEffect = MindFusion.Diagramming.GlassEffect;

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit {
  title = 'app works!';

  ngOnInit() {
    let diagram = Diagram.create(document.querySelector('#diagram'));
    diagram.getNodeEffects().push(new GlassEffect());
    diagram.setLinkHeadShapeSize(2);

    	const layout = new MindFusion.Graphs.BorderedTreeLayout();
		layout.direction = MindFusion.Graphs.LayoutDirection.LeftToRight;
		layout.multipleGraphsPlacement = MindFusion.Graphs.MultipleGraphsPlacement.Vertical;
		layout.linkType = MindFusion.Graphs.TreeLayoutLinkType.Cascading;
		layout.nodeDistance = 2;
		layout.levelDistance = 5;
    diagram.arrange(layout);
    
   // create child nodes for containers
   
    // create containers
    let ctr = [];
    for (let c = 0; c < 7; c++) {
      let container = diagram.getFactory().createContainerNode(0, 0, 10, 10);
   
      container.arrange(new MindFusion.Graphs.BorderedTreeLayout());
      container.setZIndex(0);
      container.setExpandable(true);
      container.setText(c+"");
      container.setBrush("#A09162");
      container.setHandlesStyle(HandlesStyle.HatchHandles3);
      ctr[c] = container;
    }

    ctr[0].move(10, 20, true, true);
    ctr[1].move(40, 40, true, true);
    ctr[2].move(60, 60, true, true);
    ctr[5].move(80, 80, true, true);
    ctr[6].move(250, 200, true, true);
    ctr[3].move(150, 120, true, true);
    ctr[4].move(200, 140, true, true);

    diagram.getFactory().createDiagramLink(ctr[0], ctr[1]);
    diagram.getFactory().createDiagramLink(ctr[1], ctr[2]);
    diagram.getFactory().createDiagramLink(ctr[2], ctr[3]);
    diagram.getFactory().createDiagramLink(ctr[3], ctr[4]);
    diagram.getFactory().createDiagramLink(ctr[2], ctr[5]);
    diagram.getFactory().createDiagramLink(ctr[3], ctr[6]);
    diagram.getNodes()[0].setExpanded(false);
    diagram.getNodes()[2].setExpanded(false);
    diagram.getNodes()[3].setExpanded(false);
  }
}
